=== util/CMakeLists.txt ===
add_subdirectory(fixnonlatin1)
add_subdirectory(lexgen)
add_subdirectory(normalize)
add_subdirectory(plugintest)
add_subdirectory(qlalr)
add_subdirectory(imgconv)
add_subdirectory(filehash)
