=== src/declarative/CMakeLists.txt ===
add_definitions(
    -DQT_NO_URL_CAST_FROM_STRING
)
set(EXTRA_DECLARATIVE_LIBS
    KtCore KtGui KtNetwork KtScript
)

set(DECLARATIVE_PUBLIC_HEADERS
    QDeclarativeComponent
    QDeclarativeContext
    QDeclarativeEngine
    QDeclarativeError
    QDeclarativeExpression
    QDeclarativeExtensionInterface
    QDeclarativeExtensionPlugin
    QDeclarativeImageProvider
    QDeclarativeInfo
    QDeclarativeItem
    QDeclarativeParserStatus
    QDeclarativeProperty
    QDeclarativePropertyMap
    QDeclarativePropertyValueInterceptor
    QDeclarativePropertyValueSource
    QDeclarativeScriptString
    QDeclarativeView
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${CMAKE_BINARY_DIR}/include/QtNetwork
    ${CMAKE_BINARY_DIR}/include/QtScript
    ${CMAKE_BINARY_DIR}/include/QtDeclarative
    ${CMAKE_SOURCE_DIR}/src/3rdparty/harfbuzz/src
)
set(DECLARATIVE_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitemsmodule_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanchors_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanchors_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeevents_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflickable_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflickable_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflipable_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativegridview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimagebase_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeborderimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepainteditem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepainteditem_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimage_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeborderimage_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimagebase_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanimatedimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanimatedimage_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitem.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativefocuspanel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativefocusscope_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepositioners_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepositioners_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeloader_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativemousearea_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativemousearea_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepath_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepath_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepathview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepathview_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerectangle_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerectangle_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerepeater_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerepeater_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativescalegrid_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetranslate_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextinput_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextinput_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextedit_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextedit_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetext_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativevisualitemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativelistview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativelayoutitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitemchangelistener_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativegraphicswidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimplicitsizeitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimplicitsizeitem_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeglobal_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeinstruction_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevmemetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarative.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativebinding_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativebinding_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeproperty.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecomponent.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecomponent_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecustomparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecustomparser_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativepropertyvaluesource.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativepropertyvalueinterceptor.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeboundsignal_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeparserstatus.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeproxymetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevme_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecompiler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeexpression_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeprivate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativerefcount_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativemetatype_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeengine.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecontext.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeexpression.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativestringconverters_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeinfo.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeproperty_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecontext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeinclude_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypeloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativelist.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativelist_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativedata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeerror.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativescriptparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativerewrite_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qpodvector_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevaluetype_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecompiledbindings_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qmetaobjectbuilder_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecleanup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativepropertycache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativenotifier_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeintegercache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypenotavailable_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypenamecache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativescriptstring.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeobjectscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecontextscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeglobalscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevaluetypescriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypenamescriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativelistscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeworkerscript_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeguard_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeimageprovider.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativedirparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeextensioninterface.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeimport_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeextensionplugin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsast_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsastfwd_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsastvisitor_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsgrammar_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejslexer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsmemorypool_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsnodepool_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/rewriter/textwriter_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeapplication_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeutilmodule_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeconnections_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepackage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeanimation_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativesystempalette_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativespringanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativesmoothedanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativesmoothedanimation_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestate_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestateoperations_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepropertychanges_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestate_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetransitionmanager_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestategroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetransition_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistmodel_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistaccessor_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeopenmetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativenullablevalue_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetimeline_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetimer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativebind_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepropertymap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepixmapcache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativebehavior_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestyledtext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistmodelworkeragent_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qlistmodelinterface_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdeclarativecommon_p.h
)

set(DECLARATIVE_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitemsmodule.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanchors.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeevents.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflickable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflipable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativegridview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimage.cpp
