=== src/gui/CMakeLists.txt ===
add_definitions(${PNG_DEFINITIONS})
set(EXTRA_GUI_LIBS
    KtCore KtXml
    ${FREETYPE_LIBRARIES}
    ${X11_X11_LIB}
    ${PNG_LIBRARIES}
)

set(GUI_PUBLIC_HEADERS
    QPropertyAnimation
    QPauseAnimation
    QAnimationGroup
    QVariantAnimation
    QSequentialAnimationGroup
    QParallelAnimationGroup
    QAbstractAnimation
    QAbstractButton
    QAbstractItemDelegate
    QAbstractItemView
    QAbstractPageSetupDialog
    QAbstractPrintDialog
    QAbstractProxyModel
    QAbstractScrollArea
    QAbstractSlider
    QAbstractSpinBox
    QAbstractTextDocumentLayout
    QAction
    QActionGroup
    QApplication
    QBitmap
    QBoxLayout
    QBrush
    QButtonGroup
    QCalendarWidget
    QCheckBox
    QCleanlooksStyle
    QClipboard
    QColor
    QColorDialog
    QColumnView
    QComboBox
    QCommandLinkButton
    QCommonStyle
    QCompleter
    QCursor
    QDataWidgetMapper
    QDateTimeEdit
    QDesktopWidget
    QDial
    QDialog
    QDialogButtonBox
    QDirModel
    QDockWidget
    QDrag
    QFileDialog
    QFileIconProvider
    QFileSystemModel
    QFocusFrame
    QFont
    QFontComboBox
    QFontDatabase
    QFontDialog
    QFontInfo
    QFontMetrics
    QFormLayout
    QFrame
    QGenericMatrix
    QGraphicsAnchorLayout
    QGraphicsGridLayout
    QGraphicsItem
    QGraphicsItemAnimation
    QGraphicsLayout
    QGraphicsLayoutItem
    QGraphicsLinearLayout
    QGraphicsProxyWidget
    QGraphicsScene
    QGraphicsSceneEvent
    QGraphicsView
    QGraphicsWidget
    QGridLayout
    QGroupBox
    QHeaderView
    QIcon
    QIconEngine
    QIconEnginePlugin
    QIdentityProxyModel
    QImage
    QImageIOHandler
    QImageReader
    QImageWriter
    QInputDialog
    QItemDelegate
    QItemEditorFactory
    QItemSelectionModel
    QKeySequence
    QLabel
    QLayout
    QLayoutItem
    QLCDNumber
    QLineEdit
    QListView
    QListWidget
    QMainWindow
    QMatrix
    QMatrix4x4
    QMdiArea
    QMdiSubWindow
    QMenu
    QMenuBar
    QMovie
    QPageSetupDialog
    QPaintDevice
    QPaintEngine
    QPainter
    QPainterPath
    QPalette
    QPen
    QPixmap
    QPixmapCache
    QPlainTextEdit
    QPolygon
    QPrintDialog
    QPrintEngine
    QPrinter
    QPrinterInfo
    QPrintPreviewDialog
    QPrintPreviewWidget
    QProgressBar
    QProgressDialog
    QProxyModel
    QProxyStyle
    QPushButton
    QRadioButton
    QRegion
    QRgb
    QRubberBand
    QScrollArea
    QScrollBar
    QSessionManager
    QShortcut
    QSizeGrip
    QSizePolicy
    QSlider
    QSortFilterProxyModel
    QSpinBox
    QSplashScreen
    QSplitter
    QStackedLayout
    QStackedWidget
    QStandardItemModel
    QStatusBar
    QStringListModel
    QStyle
    QStyledItemDelegate
    QStyleFactory
    QStyleOption
    QStylePainter
    QStylePlugin
    QSyntaxHighlighter
    QSystemTrayIcon
    QTabBar
    QTableView
    QTableWidget
    QTabWidget
    QTextBrowser
    QTextCursor
    QTextDocument
    QTextDocumentFragment
    QTextDocumentWriter
    QTextEdit
    QTextFormat
    QTextLayout
    QTextList
    QTextObject
    QTextOption
    QTextTable
    QToolBar
    QToolBox
    QToolButton
    QToolTip
    QTransform
    QTreeView
    QTreeWidget
    QTreeWidgetItemIterator
    QUndoGroup
    QUndoStack
    QUndoView
    QValidator
    QVector2D
    QVector3D
    QVector4D
    QWhatsThis
    QWidget
    QMessageBox
    QWidgetAction
    QWindowsStyle
    QWizard
    QGuiPlatformPlugin
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtXml
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${FREETYPE_INCLUDE_DIRS}
    ${X11_INCLUDE_DIR}
    ${PNG_INCLUDE_DIRS}
)

set(GUI_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qabstractanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qabstractanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qvariantanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qvariantanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qpropertyanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qpropertyanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qanimationgroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qanimationgroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qsequentialanimationgroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qsequentialanimationgroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qparallelanimationgroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qparallelanimationgroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qpauseanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractprintdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractprintdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractpagesetupdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractpagesetupdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qcolordialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qcolordialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfscompleter_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfiledialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfiledialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfontdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfontdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qinputdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qmessagebox.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qpagesetupdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qpagesetupdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qpagesetupdialog_unix_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprintdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprintdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprogressdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qsidebar_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfilesystemmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfilesystemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfileinfogatherer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qwizard.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprintpreviewdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsgridlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsitem.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsitemanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayout_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayoutitem.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayoutitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslinearlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsproxywidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsproxywidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscene.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscene_bsp_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscene_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscenebsptreeindex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicssceneevent.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicssceneindex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscenelinearindex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicstransform.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicstransform_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicswidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicswidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgridlayoutengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraph_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qsimplex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsanchorlayout_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsanchorlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qbitmap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qicon.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qicon_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qiconloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qiconengine.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qiconengineplugin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimage.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimageiohandler.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimagereader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimagewriter.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qmovie.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpixmap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpixmapcache.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpixmapdata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qppmhandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qxpmhandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpnghandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qkathandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractitemview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractitemview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qheaderview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qheaderview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qidentityproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qbsptree_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtableview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtableview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreeview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreeview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractitemdelegate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemdelegate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemselectionmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemselectionmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qdirmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistwidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistwidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtablewidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtablewidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qwidgetitemdata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qproxymodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractproxymodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qsortfilterproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemeditorfactory.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemeditorfactory_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstandarditemmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstandarditemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstringlistmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidgetitemiterator.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidgetitemiterator_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qdatawidgetmapper.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qfileiconprovider.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qcolumnviewgrip_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qcolumnview.h 
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qcolumnview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstyleditemdelegate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qaction.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qaction_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qactiongroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qapplication.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qapplication_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qboxlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qclipboard.h
