=== package/debian/changelog ===
katie (4.12.0) unstable; urgency=medium

  * Seventh package update

 -- Ivailo Monev <xakepa10@gmail.com>  Tue, 14 Dec 2021 09:36:46 +0200

katie (4.11.1) stable; urgency=medium

  * Sixed package update

 -- Ivailo Monev <xakepa10@gmail.com>  Tue, 23 Nov 2021 12:49:58 +0200

katie (4.11.0) stable; urgency=medium

  * Fifth package update

 -- Ivailo Monev <xakepa10@gmail.com>  Fri, 13 Aug 2021 07:32:58 +0200

katie (4.10.0) stable; urgency=medium

  * Fourth package update

 -- Ivailo Monev <xakepa10@gmail.com>  Mon, 8 Feb 2020 14:44:00 +0200

katie (4.9.2) stable; urgency=medium

  * Third package update

 -- Ivailo Monev <xakepa10@gmail.com>  Thu, 31 Dec 2020 14:44:00 +0200

katie (4.9.1) unstable; urgency=medium

  * Second package update

 -- Ivailo Monev <xakepa10@gmail.com>  Thu, 17 Dec 2020 16:26:26 +0200

katie (4.9.0) unstable; urgency=medium

  * First package update

 -- Ivailo Monev <xakepa10@gmail.com>  Mon, 7 Mar 2016 16:26:26 +0200

katie (4.8.7) unstable; urgency=medium

  * Initial package

 -- Ivailo Monev <xakepa10@gmail.com>  Sun, 10 Jan 2016 21:28:59 +0200
