=== package/debian/control ===
Source: katie
Priority: optional
Maintainer: Ivailo Monev <xakepa10@gmail.com>
Homepage: https://osdn.net/projects/kde/
Vcs-Git: git://git.osdn.net/gitroot/kde/Katie.git
Vcs-browser: https://osdn.net/projects/kde/scm/git/Katie/tree
Standards-Version: 4.12.0
Build-Depends: debhelper (>= 9~), libdeflate-dev, libgettextpo-dev,
 libc6-dev, libjansson-dev, libpng-dev, libcups2-dev, libfreetype6-dev,
 libfontconfig1-dev, libdbus-1-dev, libicu-dev, cmake, git,
 xserver-xorg-dev, libxinerama-dev, libxrandr-dev, libxrender-dev,
 libxcursor-dev, libsm-dev, unifdef | dpkg

Package: katie-runtime
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x hurd-i386
Section: x11
Depends: ${shlibs:Depends}, ${misc:Depends}, xdg-utils
Recommends: xserver-xorg-core, fonts-freefont-ttf
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes includes libraries, imports, plugins and translations

Package: katie-tools
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x hurd-i386
Section: x11
Depends: ${shlibs:Depends}, ${misc:Depends}, katie-runtime
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes designer, moc, qdbus, qdbuscpp2xml, qdbusviewer,
 qdbusxml2cpp, qscript, qtconfig, rcc, and uic

Package: katie-dev
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x hurd-i386
Section: devel
Depends: ${misc:Depends}, katie-runtime, katie-tools
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes headers, pkg-config and CMake files

Package: katie-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, man-db
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes manual pages for the tools
