=== package/debian/rules ===
#!/usr/bin/make -f

KATIE_CROSS_EMULATOR=""
ifneq ($(DEB_HOST_ARCH_CPU),$(DEB_BUILD_ARCH_CPU))
	KATIE_CROSS_EMULATOR="qemu-$(DEB_HOST_GNU_CPU)-static"
endif

KATIE_BUILD_DIR="$(shell pwd)/obj-$(DEB_HOST_GNU_TYPE)"

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps -l$(KATIE_BUILD_DIR)/lib

override_dh_auto_configure:
	dh_auto_configure -- -Wno-dev \
		-DKATIE_TOOLS_SUFFIX="-katie" \
		-DCMAKE_CROSSCOMPILING_EMULATOR=$(KATIE_CROSS_EMULATOR)

override_dh_auto_install:
	$(MAKE) -C $(KATIE_BUILD_DIR) install-runtime DESTDIR=../debian/katie-runtime
	rm -vrf debian/katie-runtime/etc/
	$(MAKE) -C $(KATIE_BUILD_DIR) install-tools DESTDIR=../debian/katie-tools
	$(MAKE) -C $(KATIE_BUILD_DIR) install-devel DESTDIR=../debian/katie-dev
	$(MAKE) -C $(KATIE_BUILD_DIR) install-doc DESTDIR=../debian/katie-doc
	dpkg-gensymbols -q -Odebian/katie-runtime.symbols -Pdebian/katie-runtime -pkatie-runtime
